error.c File Reference
`#include "ruby/ruby.h"`
`#include "ruby/st.h"`
`#include "ruby/encoding.h"`
`#include "internal.h"`
`#include "vm_core.h"`
`#include <stdio.h>`
`#include <stdarg.h>`
`#include <errno.h>`
`#include "known_errors.inc"`

Go to the source code of this file.

## Data Structures

struct | types

## Macros

#define | EXIT_SUCCESS 0
#define | WIFEXITED(status) 1
#define | WEXITSTATUS(status) (status)
#define | REPORTBUG_MSG
#define | defined_error(name, num) if (err == (num)) return (name);
#define | undefined_error(name)
#define | write_or_abort(fd, str, len) (write((fd), (str), (len)) < 0 ? abort() : (void)0)
#define | WRITE_CONST(fd, str) write_or_abort((fd),(str),sizeof(str) - 1)
#define | NAME_ERR_MESG_COUNT 3
#define | name_err_mesg_free RUBY_TYPED_DEFAULT_FREE
#define | defined_error(name, num) set_syserr((num), (name));
#define | undefined_error(name) set_syserr(0, (name));

## Functions

static const char * | rb_strerrno (int err)
static int | err_position_0 (char *buf, long len, const char *file, int line)
static int | err_position (char *buf, long len)
static void | err_snprintf (char *buf, long len, const char *fmt, va_list args)
static void | compile_snprintf (char *buf, long len, const char *file, int line, const char *fmt, va_list args)
static void | err_append (const char *, rb_encoding *)
void | rb_compile_error_with_enc (const char *file, int line, void *enc, const char *fmt,...)
void | rb_compile_error (const char *file, int line, const char *fmt,...)
void | rb_compile_error_append (const char *fmt,...)
static void | compile_warn_print (const char *file, int line, const char *fmt, va_list args)
void | rb_compile_warn (const char *file, int line, const char *fmt,...)
void | rb_compile_warning (const char *file, int line, const char *fmt,...)
static void | warn_print (const char *fmt, va_list args)
void | rb_warn (const char *fmt,...)
void | rb_warning (const char *fmt,...)
static VALUE | rb_warn_m (VALUE self, VALUE mesg)
static void | report_bug (const char *file, int line, const char *fmt, va_list args)
void | rb_bug (const char *fmt,...)
void | rb_bug_errno (const char *mesg, int errno_arg)
void | rb_async_bug_errno (const char *mesg, int errno_arg)
void | rb_compile_bug (const char *file, int line, const char *fmt,...)
void | rb_check_type (VALUE x, int t)
int | rb_typeddata_inherited_p (const rb_data_type_t *child, const rb_data_type_t *parent)
int | rb_typeddata_is_kind_of (VALUE obj, const rb_data_type_t *data_type)
void * | rb_check_typeddata (VALUE obj, const rb_data_type_t *data_type)
VALUE | rb_exc_new (VALUE etype, const char *ptr, long len)
VALUE | rb_exc_new2 (VALUE etype, const char *s)
VALUE | rb_exc_new3 (VALUE etype, VALUE str)
static VALUE | exc_initialize (int argc, VALUE *argv, VALUE exc)
static VALUE | exc_exception (int argc, VALUE *argv, VALUE self)
static VALUE | exc_to_s (VALUE exc)
static VALUE | exc_message (VALUE exc)
static VALUE | exc_inspect (VALUE exc)
static VALUE | exc_backtrace (VALUE exc)
VALUE | rb_check_backtrace (VALUE bt)
static VALUE | exc_set_backtrace (VALUE exc, VALUE bt)
static VALUE | exc_equal (VALUE exc, VALUE obj)
static VALUE | exit_initialize (int argc, VALUE *argv, VALUE exc)
static VALUE | exit_status (VALUE exc)
static VALUE | exit_success_p (VALUE exc)
void | rb_name_error (ID id, const char *fmt,...)
static VALUE | name_err_initialize (int argc, VALUE *argv, VALUE self)
static VALUE | name_err_name (VALUE self)
static VALUE | name_err_to_s (VALUE exc)
static VALUE | nometh_err_initialize (int argc, VALUE *argv, VALUE self)
static void | name_err_mesg_mark (void *p)
static size_t | name_err_mesg_memsize (const void *p)
VALUE | rb_name_err_mesg_new (VALUE obj, VALUE mesg, VALUE recv, VALUE method)
static VALUE | name_err_mesg_equal (VALUE obj1, VALUE obj2)
static VALUE | name_err_mesg_to_str (VALUE obj)
static VALUE | name_err_mesg_load (VALUE klass, VALUE str)
static VALUE | nometh_err_args (VALUE self)
void | rb_invalid_str (const char *str, const char *type)
static VALUE | set_syserr (int n, const char *name)
static VALUE | get_syserr (int n)
static VALUE | syserr_initialize (int argc, VALUE *argv, VALUE self)
static VALUE | syserr_errno (VALUE self)
static VALUE | syserr_eqq (VALUE self, VALUE exc)
void | Init_Exception (void)
void | rb_raise (VALUE exc, const char *fmt,...)
void | rb_loaderror (const char *fmt,...)
void | rb_notimplement (void)
void | rb_fatal (const char *fmt,...)
static VALUE | make_errno_exc (const char *mesg)
static VALUE | make_errno_exc_str (VALUE mesg)
VALUE | rb_syserr_new (int n, const char *mesg)
VALUE | rb_syserr_new_str (int n, VALUE arg)
void | rb_syserr_fail (int e, const char *mesg)
void | rb_syserr_fail_str (int e, VALUE mesg)
void | rb_sys_fail (const char *mesg)
void | rb_sys_fail_str (VALUE mesg)
void | rb_mod_sys_fail (VALUE mod, const char *mesg)
void | rb_mod_sys_fail_str (VALUE mod, VALUE mesg)
void | rb_mod_syserr_fail (VALUE mod, int e, const char *mesg)
void | rb_mod_syserr_fail_str (VALUE mod, int e, VALUE mesg)
void | rb_sys_warning (const char *fmt,...)
void | rb_load_fail (const char *path)
void | rb_error_frozen (const char *what)
void | rb_check_frozen (VALUE obj)
void | Init_syserr (void)

## Variables

const char | ruby_description []
static struct types | builtin_types []
VALUE | rb_eException
VALUE | rb_eSystemExit
VALUE | rb_eInterrupt
VALUE | rb_eSignal
VALUE | rb_eFatal
VALUE | rb_eStandardError
VALUE | rb_eRuntimeError
VALUE | rb_eTypeError
VALUE | rb_eArgError
VALUE | rb_eIndexError
VALUE | rb_eKeyError
VALUE | rb_eRangeError
VALUE | rb_eNameError
VALUE | rb_eEncodingError
VALUE | rb_eEncCompatError
VALUE | rb_eNoMethodError
VALUE | rb_eSecurityError
VALUE | rb_eNotImpError
VALUE | rb_eNoMemError
VALUE | rb_cNameErrorMesg
VALUE | rb_eScriptError
VALUE | rb_eSyntaxError
VALUE | rb_eLoadError
VALUE | rb_eSystemCallError
VALUE | rb_mErrno
static VALUE | rb_eNOERROR
static const rb_data_type_t | name_err_mesg_data_type
static st_table * | syserr_tbl

## Macro Definition Documentation

#define defined_error | ( |  | name,
|  |  | num
| ) |  | if (err == (num)) return (name);

#define defined_error | ( |  | name,
|  |  | num
| ) |  | set_syserr((num), (name));

#define EXIT_SUCCESS 0

Definition at line 29 of file error.c.

Referenced by error_handle(), exit_initialize(), exit_success_p(), goruby_run_node(), options(), rb_thread_kill(), ruby_cleanup(), and ruby_executable_node().

#define NAME_ERR_MESG_COUNT 3

Definition at line 883 of file error.c.

Referenced by Init_Exception(), name_err_mesg_equal(), name_err_mesg_mark(), name_err_mesg_memsize(), name_err_mesg_to_str(), and rb_name_err_mesg_new().

#define name_err_mesg_free RUBY_TYPED_DEFAULT_FREE

Definition at line 892 of file error.c.

#define REPORTBUG_MSG

Value:
"[NOTE]\n" \
"You may have encountered a bug in the Ruby interpreter" \
" or extension libraries.\n" \
"Bug reports are welcome.\n" \
"For details: http://www.ruby-lang.org/bugreport.html\n\n" \

Definition at line 42 of file error.c.

Referenced by rb_async_bug_errno(), and report_bug().

#define undefined_error | ( |  | name | ) |

#define undefined_error | ( |  | name | ) | set_syserr(0, (name));

#define WEXITSTATUS | ( |  | status | ) | (status)

Definition at line 37 of file error.c.

Referenced by exit_success_p().

#define WIFEXITED | ( |  | status | ) | 1

Definition at line 33 of file error.c.

Referenced by exit_success_p().

#define WRITE_CONST | ( |  | fd,
|  |  | str
| ) |  | write_or_abort((fd),(str),sizeof(str) - 1)

Definition at line 306 of file error.c.

Referenced by rb_async_bug_errno().

#define write_or_abort | ( |  | fd,
|  |  | str,
|  |  | len
| ) |  | (write((fd), (str), (len)) < 0 ? abort() : (void)0)

Definition at line 305 of file error.c.

Referenced by rb_async_bug_errno().

## Function Documentation

static void compile_snprintf | ( | char * | buf,
|  | long | len,
|  | const char * | file,
|  | int | line,
|  | const char * | fmt,
|  | va_list | args
| ) |  |

static

Definition at line 92 of file error.c.

References err_position_0(), and vsnprintf.

Referenced by compile_warn_print(), rb_compile_error(), and rb_compile_error_with_enc().

static void compile_warn_print | ( | const char * | file,
|  | int | line,
|  | const char * | fmt,
|  | va_list | args
| ) |  |

static

Definition at line 141 of file error.c.

References buf, compile_snprintf(), len, rb_write_error2(), and strlen().

Referenced by rb_compile_warn(), and rb_compile_warning().

static void err_append | ( | const char * | s,
|  | rb_encoding * | enc
| ) |  |

static

Definition at line 1771 of file error.c.

References err, rb_thread_struct::errinfo, GET_THREAD, rb_thread_struct::mild_compile_error, rb_enc_str_new(), rb_eSyntaxError, rb_exc_new2(), rb_exc_new3(), rb_obj_as_string(), rb_str_cat2(), rb_write_error(), RTEST, and strlen().

Referenced by rb_compile_error(), rb_compile_error_append(), and rb_compile_error_with_enc().

static int err_position | ( | char * | buf,
|  | long | len
| ) |  |

static

Definition at line 75 of file error.c.

References err_position_0(), rb_sourcefile, and rb_sourceline().

Referenced by err_snprintf().

static int err_position_0 | ( | char * | buf,
|  | long | len,
|  | const char * | file,
|  | int | line
| ) |  |

static

Definition at line 61 of file error.c.

References snprintf.

Referenced by compile_snprintf(), err_position(), and report_bug().

static void err_snprintf | ( | char * | buf,
|  | long | len,
|  | const char * | fmt,
|  | va_list | args
| ) |  |

static

Definition at line 81 of file error.c.

References err_position(), and vsnprintf.

Referenced by warn_print().

static VALUE exc_backtrace | ( | VALUE | exc | ) |

static

Definition at line 650 of file error.c.

References CONST_ID, and rb_attr_get().

Referenced by exc_equal(), and Init_Exception().

static VALUE exc_equal | ( | VALUE | exc,
|  | VALUE | obj
| ) |  |

static

Definition at line 706 of file error.c.

References CONST_ID, exc_backtrace(), Qfalse, Qtrue, Qundef, rb_attr_get(), rb_check_funcall(), rb_equal(), and rb_obj_class().

Referenced by Init_Exception().

static VALUE exc_exception | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | self
| ) |  |

static

Definition at line 544 of file error.c.

References exc_initialize(), and rb_obj_clone().

Referenced by Init_Exception().

static VALUE exc_initialize | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | exc
| ) |  |

static

Definition at line 519 of file error.c.

References arg, Qnil, rb_iv_set(), and rb_scan_args().

Referenced by exc_exception(), and Init_Exception().

static VALUE exc_inspect | ( | VALUE | exc | ) |

static

Definition at line 600 of file error.c.

References CLASS_OF, rb_class_name(), rb_obj_as_string(), rb_str_buf_append(), rb_str_buf_cat(), rb_str_buf_new2(), rb_str_dup(), and RSTRING_LEN.

Referenced by Init_Exception().

static VALUE exc_message | ( | VALUE | exc | ) |

static

Definition at line 587 of file error.c.

References rb_funcall(), and rb_intern.

Referenced by Init_Exception().

static VALUE exc_set_backtrace | ( | VALUE | exc,
|  | VALUE | bt
| ) |  |

static

Definition at line 691 of file error.c.

References rb_check_backtrace(), and rb_iv_set().

Referenced by Init_Exception().

static VALUE exc_to_s | ( | VALUE | exc | ) |

static

Definition at line 565 of file error.c.

References CLASS_OF, NIL_P, OBJ_INFECT, Qnil, rb_attr_get(), rb_class_name(), rb_intern, and rb_String().

Referenced by Init_Exception().

static VALUE exit_initialize | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | exc
| ) |  |

static

Definition at line 744 of file error.c.

References argc, EXIT_SUCCESS, FIXNUM_P, INT2FIX, rb_call_super(), and rb_iv_set().

Referenced by Init_Exception().

static VALUE exit_status | ( | VALUE | exc | ) |

static

Definition at line 765 of file error.c.

References rb_attr_get(), and rb_intern.

Referenced by Init_Exception().

static VALUE exit_success_p | ( | VALUE | exc | ) |

static

Definition at line 779 of file error.c.

References EXIT_SUCCESS, NIL_P, NUM2INT, Qfalse, Qtrue, rb_attr_get(), rb_intern, WEXITSTATUS, and WIFEXITED.

Referenced by Init_Exception().

static VALUE get_syserr | ( | int | n | ) |

static

Definition at line 1074 of file error.c.

References name, set_syserr(), snprintf, and st_lookup.

Referenced by rb_syserr_new_str().

void Init_Exception | ( | void |  | ) |

Definition at line 1514 of file error.c.

References exc_backtrace(), exc_equal(), exc_exception(), exc_initialize(), exc_inspect(), exc_message(), exc_set_backtrace(), exc_to_s(), exit_initialize(), exit_status(), exit_success_p(), name_err_initialize(), NAME_ERR_MESG_COUNT, name_err_mesg_equal(), name_err_mesg_load(), name_err_mesg_to_str(), name_err_name(), name_err_to_s(), nometh_err_args(), nometh_err_initialize(), rb_cData, rb_cEncoding, rb_class_new_instance(), rb_cNameErrorMesg, rb_cObject, rb_define_class(), rb_define_class_under(), rb_define_global_function(), rb_define_method(), rb_define_module(), rb_define_singleton_method(), rb_eArgError, rb_eEncCompatError, rb_eEncodingError, rb_eException, rb_eFatal, rb_eIndexError, rb_eInterrupt, rb_eKeyError, rb_eLoadError, rb_eNameError, rb_eNoMemError, rb_eNoMethodError, rb_eNotImpError, rb_eRangeError, rb_eRuntimeError, rb_eScriptError, rb_eSecurityError, rb_eSignal, rb_eStandardError, rb_eSyntaxError, rb_eSystemCallError, rb_eSystemExit, rb_eTypeError, rb_mErrno, rb_name_err_mesg_new(), rb_warn_m(), st_init_numtable, syserr_eqq(), syserr_errno(), and syserr_initialize().

void Init_syserr | ( | void |  | ) |

Definition at line 1760 of file error.c.

References rb_eNOERROR, and set_syserr().

static VALUE make_errno_exc | ( | const char * | mesg | ) |

static

Definition at line 1625 of file error.c.

References errno, rb_bug(), and rb_syserr_new().

Referenced by rb_mod_sys_fail(), and rb_sys_fail().

static VALUE make_errno_exc_str | ( | VALUE | mesg | ) |

static

Definition at line 1637 of file error.c.

References errno, NIL_P, Qnil, rb_bug(), rb_syserr_new_str(), and RSTRING_PTR.

Referenced by rb_mod_sys_fail_str(), and rb_sys_fail_str().

static VALUE name_err_initialize | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | self
| ) |  |

static

Definition at line 818 of file error.c.

References name, Qnil, rb_call_super(), and rb_iv_set().

Referenced by Init_Exception(), and nometh_err_initialize().

static VALUE name_err_mesg_equal | ( | VALUE | obj1,
|  | VALUE | obj2
| ) |  |

static

Definition at line 928 of file error.c.

References i, NAME_ERR_MESG_COUNT, Qfalse, Qtrue, rb_cNameErrorMesg, rb_equal(), rb_obj_class(), and TypedData_Get_Struct.

Referenced by Init_Exception().

static VALUE name_err_mesg_load | ( | VALUE | klass,
|  | VALUE | str
| ) |  |

static

Definition at line 997 of file error.c.

Referenced by Init_Exception().

static void name_err_mesg_mark | ( | void * | p | ) |

static

Definition at line 886 of file error.c.

References NAME_ERR_MESG_COUNT, p, and rb_gc_mark_locations.

static size_t name_err_mesg_memsize | ( | const void * | p | ) |

static

Definition at line 895 of file error.c.

References NAME_ERR_MESG_COUNT.

static VALUE name_err_mesg_to_str | ( | VALUE | obj | ) |

static

Definition at line 948 of file error.c.

References args, NAME_ERR_MESG_COUNT, NIL_P, OBJ_INFECT, Qnil, rb_any_to_s(), rb_f_sprintf(), rb_inspect(), rb_obj_classname(), rb_protect(), rb_set_errinfo(), rb_str_cat2(), rb_str_dup(), rb_str_new2(), RSTRING_LEN, RSTRING_PTR, T_FALSE, T_NIL, T_TRUE, TYPE, and TypedData_Get_Struct.

Referenced by Init_Exception().

static VALUE name_err_name | ( | VALUE | self | ) |

static

Definition at line 836 of file error.c.

References rb_attr_get(), and rb_intern.

Referenced by Init_Exception().

static VALUE name_err_to_s | ( | VALUE | exc | ) |

static

Definition at line 849 of file error.c.

References CLASS_OF, NIL_P, OBJ_INFECT, rb_attr_get(), rb_class_name(), rb_intern, rb_iv_set(), and StringValue.

Referenced by Init_Exception().

static VALUE nometh_err_args | ( | VALUE | self | ) |

static

Definition at line 1011 of file error.c.

References rb_attr_get(), and rb_intern.

Referenced by Init_Exception().

static VALUE nometh_err_initialize | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | self
| ) |  |

static

Definition at line 874 of file error.c.

References args, name_err_initialize(), Qnil, and rb_iv_set().

Referenced by Init_Exception().

void rb_async_bug_errno | ( | const char * | mesg,
|  | int | errno_arg
| ) |  |

Definition at line 309 of file error.c.

References rb_strerrno(), REPORTBUG_MSG, ruby_description, strlen(), WRITE_CONST, and write_or_abort.

void rb_bug | ( | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 265 of file error.c.

References args, GET_THREAD, NULL, rb_sourcefile, rb_sourceline(), and report_bug().

Referenced by add_opt_method(), assign_heap_slot(), big2str_find_n1(), big_fdiv(), BigDecimalCmp(), catch_type(), check_env_value(), classname(), compile_array_(), cont_free(), econv_convert(), econv_finish(), error_handle(), eval_queue_handler(), eventloop_sleep(), exception_type2symbol(), fiber_store(), fiber_switch(), gc_mark_children(), get_dyna_var_idx(), get_local_var_idx(), glob_helper(), insn_operand_intern(), ip_rb_threadUpdateCommand(), ip_rbUpdateCommand(), ip_rbVwaitCommand(), iseq_compile_each(), iseq_data_to_ary(), iseq_set_arguments(), iseq_set_sequence(), m_core_set_postexe(), make_errno_exc(), make_errno_exc_str(), memsize_of(), mutex_free(), obj_free(), pack_pack(), pack_unpack(), power_cache_get_power(), rb_add_method(), rb_bug_errno(), rb_check_deadlock(), rb_check_type(), rb_dlhandle_initialize(), rb_dlptr_aref(), rb_dlptr_aset(), rb_dlptr_s_malloc(), rb_dlptr_to_s(), rb_dlptr_to_str(), rb_econv_open_opts(), rb_enc_from_encoding_index(), rb_fiber_start(), rb_gc_mark_threads(), rb_iseq_compile_node(), rb_memsearch_ss(), rb_method_definition_eq(), rb_method_entry_arity(), rb_newobj(), rb_str_set_len(), rb_struct_eql(), rb_struct_equal(), rb_thread_call_with_gvl(), rb_thread_terminate_all(), rb_threadptr_unlock_all_locking_mutexes(), rb_trans_conv(), rb_update_max_fd(), rb_vm_make_proc(), rsock_s_recvfrom(), rsock_s_recvfrom_nonblock(), ruby_node_name(), setup_args(), singleton_class_of(), tcl_protect(), thread_free(), thread_start_func_2(), verify_list(), vm_call0(), vm_call_cfunc(), vm_call_method(), vm_call_super(), vm_exec_core(), vm_get_cref(), vm_getspecial(), vm_make_env_each(), vm_search_normal_superclass(), vm_throw(), VpDivd(), vtable_add(), and warn_unused_var().

void rb_bug_errno | ( | const char * | mesg,
|  | int | errno_arg
| ) |  |

Definition at line 288 of file error.c.

References rb_bug(), rb_strerrno(), and strerror().

VALUE rb_check_backtrace | ( | VALUE | bt | ) |

Definition at line 659 of file error.c.

References err, i, NIL_P, RARRAY_LEN, RARRAY_PTR, rb_ary_new3(), rb_eTypeError, rb_raise(), T_ARRAY, T_STRING, and TYPE.

Referenced by exc_set_backtrace(), and get_backtrace().

void rb_check_frozen | ( | VALUE | obj | ) |

Definition at line 1754 of file error.c.

References rb_check_frozen_internal.

void rb_check_type | ( | VALUE | x,
|  | int | t
| ) |  |

Definition at line 374 of file error.c.

References builtin_types, FIXNUM_P, types::name, NIL_P, Qundef, rb_bug(), rb_eTypeError, rb_fatal(), rb_obj_as_string(), rb_obj_classname(), rb_raise(), rb_special_const_p(), RTYPEDDATA_P, StringValuePtr, SYMBOL_P, T_DATA, T_MASK, type, types::type, and TYPE.

Referenced by tcl2rb_bool(), tcl2rb_num_or_nil(), tcl2rb_num_or_str(), tcl2rb_string(), and tkstr_to_number().

void* rb_check_typeddata | ( | VALUE | obj,
|  | const rb_data_type_t * | data_type
| ) |  |

Definition at line 440 of file error.c.

References BUILTIN_TYPE, Check_Type, DATA_PTR, rb_eTypeError, rb_obj_classname(), rb_raise(), rb_typeddata_inherited_p(), RTYPEDDATA_P, RTYPEDDATA_TYPE, SPECIAL_CONST_P, T_DATA, and rb_data_type_struct::wrap_struct_name.

Referenced by check_addrinfo(), dir_check(), and econv_init().

void rb_compile_bug | ( | const char * | file,
|  | int | line,
|  | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 333 of file error.c.

References args, and report_bug().

void rb_compile_error | ( | const char * | file,
|  | int | line,
|  | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 117 of file error.c.

References args, buf, compile_snprintf(), err_append(), and NULL.

Referenced by iseq_build_from_ary_body(), iseq_set_sequence(), iseq_set_sequence_stackcaching(), and rb_iseq_compile_node().

void rb_compile_error_append | ( | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 129 of file error.c.

References args, buf, err_append(), NULL, and vsnprintf.

Referenced by parser_yyerror().

void rb_compile_error_with_enc | ( | const char * | file,
|  | int | line,
|  | void * | enc,
|  | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 105 of file error.c.

References args, buf, compile_snprintf(), and err_append().

void rb_compile_warn | ( | const char * | file,
|  | int | line,
|  | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 153 of file error.c.

References args, buf, compile_warn_print(), NIL_P, ruby_verbose, and snprintf.

Referenced by onig_syntax_warn(), parser_warn(), token_info_pop(), and warn_unused_var().

void rb_compile_warning | ( | const char * | file,
|  | int | line,
|  | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 169 of file error.c.

References args, buf, compile_warn_print(), RTEST, ruby_verbose, and snprintf.

Referenced by iseq_set_sequence(), parser_set_token_info(), parser_warning(), and rb_method_entry_make().

void rb_error_frozen | ( | const char * | what | ) |

Definition at line 1747 of file error.c.

References rb_eRuntimeError, and rb_raise().

Referenced by fdbm_modify(), generic_ivar_set(), rb_frozen_class_p(), rb_gdbm_modify(), and rb_thread_local_aset().

VALUE rb_exc_new | ( | VALUE | etype,
|  | const char * | ptr,
|  | long | len
| ) |  |

Definition at line 492 of file error.c.

References rb_funcall(), rb_intern, and rb_str_new().

Referenced by ossl_make_error(), rb_exc_new2(), and setup_exception().

VALUE rb_exc_new2 | ( | VALUE | etype,
|  | const char * | s
| ) |  |

Definition at line 498 of file error.c.

References rb_exc_new(), and strlen().

Referenced by create_ip_exc(), err_append(), fiber_switch(), gzfile_raise(), Init_Thread(), ip_create_slave_core(), ip_eval_real(), ip_get_variable2_core(), ip_invoke_core(), ip_make_safe_core(), ip_rb_threadTkWaitCommand(), ip_rb_threadUpdateCommand(), ip_rb_threadVwaitCommand(), ip_rbTkWaitCommand(), ip_rbUpdateCommand(), ip_rbVwaitCommand(), ip_ruby_cmd(), ip_ruby_eval(), ip_RubyExitCommand(), ip_set_variable2_core(), lib_eventloop_core(), lib_eventloop_main(), lib_restart_core(), make_localjump_error(), next_i(), raise_from_check(), raise_zlib_error(), tcl_protect_core(), and tcltkip_init_tk().

VALUE rb_exc_new3 | ( | VALUE | etype,
|  | VALUE | str
| ) |  |

Definition at line 504 of file error.c.

References rb_funcall(), rb_intern, and StringValue.

Referenced by argument_error(), cannot_be_coerced_into_BigDecimal(), err_append(), finish_writeconv(), Init_eval(), Init_GC(), Init_Proc(), ip_eval(), ip_invoke_with_position(), load_failed(), make_econv_exception(), make_exception(), random_rand(), rb_econv_open_exc(), rb_enc_reg_error_desc(), rb_fatal(), rb_loaderror(), rb_raise(), tcl_protect_core(), thread_start_func_2(), and tk_funcall().

void rb_fatal | ( | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 1612 of file error.c.

References args, rb_eFatal, rb_exc_fatal(), rb_exc_new3(), and rb_vsprintf().

Referenced by argf_next_argv(), proc_options(), rb_check_type(), rb_scan_args(), rb_w32_asynchronize(), StartSockets(), and VpException().

void rb_invalid_str | ( | const char * | str,
|  | const char * | type
| ) |  |

Definition at line 1017 of file error.c.

References rb_eArgError, rb_raise(), rb_str_inspect(), rb_str_new2(), and RSTRING_PTR.

Referenced by rb_cstr_to_dbl(), and rb_cstr_to_inum().

void rb_load_fail | ( | const char * | path | ) |

Definition at line 1741 of file error.c.

References errno, rb_loaderror(), and strerror().

Referenced by load_file_internal().

void rb_loaderror | ( | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 1592 of file error.c.

References args, rb_eLoadError, rb_enc_vsprintf(), rb_exc_new3(), rb_exc_raise(), and rb_locale_encoding().

Referenced by dln_load(), and rb_load_fail().

void rb_mod_sys_fail | ( | VALUE | mod,
|  | const char * | mesg
| ) |  |

Definition at line 1689 of file error.c.

References make_errno_exc(), rb_exc_raise(), and rb_extend_object().

Referenced by io_getpartial(), rb_io_write_nonblock(), rsock_s_accept_nonblock(), rsock_s_recvfrom_nonblock(), and sock_connect_nonblock().

void rb_mod_sys_fail_str | ( | VALUE | mod,
|  | VALUE | mesg
| ) |  |

Definition at line 1697 of file error.c.

References make_errno_exc_str(), rb_exc_raise(), and rb_extend_object().

void rb_mod_syserr_fail | ( | VALUE | mod,
|  | int | e,
|  | const char * | mesg
| ) |  |

Definition at line 1705 of file error.c.

References rb_exc_raise(), rb_extend_object(), and rb_syserr_new().

void rb_mod_syserr_fail_str | ( | VALUE | mod,
|  | int | e,
|  | VALUE | mesg
| ) |  |

Definition at line 1713 of file error.c.

References rb_exc_raise(), rb_extend_object(), and rb_syserr_new_str().

VALUE rb_name_err_mesg_new | ( | VALUE | obj,
|  | VALUE | mesg,
|  | VALUE | recv,
|  | VALUE | method
| ) |  |

Definition at line 911 of file error.c.

References ALLOC_N, NAME_ERR_MESG_COUNT, rb_cNameErrorMesg, RB_GC_GUARD, result, and TypedData_Wrap_Struct.

Referenced by Init_Exception(), and raise_method_missing().

void rb_name_error | ( | ID | id,
|  | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 794 of file error.c.

References args, argv, ID2SYM, rb_class_new_instance(), rb_eNameError, rb_exc_raise(), and rb_vsprintf().

Referenced by make_struct(), mnew(), range_initialize(), rb_attr(), rb_const_get_0(), rb_const_remove(), rb_cv_get(), rb_cv_set(), rb_cvar_get(), rb_define_class_id_under(), rb_define_class_variable(), rb_f_untrace_var(), rb_mod_const_defined(), rb_mod_const_get(), rb_mod_const_set(), rb_mod_cvar_defined(), rb_mod_cvar_get(), rb_mod_cvar_set(), rb_mod_remove_const(), rb_mod_remove_cvar(), rb_obj_ivar_defined(), rb_obj_ivar_get(), rb_obj_ivar_set(), rb_obj_remove_instance_variable(), rb_print_undef(), rb_struct_aref_id(), rb_struct_aset_id(), rb_struct_getmember(), rb_struct_set(), rb_undef(), readonly_setter(), remove_method(), set_const_visibility(), and uninitialized_constant().

void rb_notimplement | ( | void |  | ) |

Definition at line 1604 of file error.c.

References rb_eNotImpError, rb_frame_this_func(), rb_id2name(), and rb_raise().

Referenced by bug_i(), flock(), get_iconv_opt_i(), io_cntl(), ip_create_console_core(), ip_make_menu_embeddable_core(), p_gid_change_privilege(), p_gid_exchange(), p_uid_change_privilege(), p_uid_exchange(), rb_f_notimplement(), rb_remove_history(), rb_setegid_core(), rb_seteuid_core(), and strio_unimpl().

void rb_raise | ( | VALUE | exc,
|  | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 1580 of file error.c.

References args, rb_exc_new3(), rb_exc_raise(), and rb_vsprintf().

Referenced by addrinfo_initialize(), addrinfo_ip_address(), addrinfo_ip_port(), addrinfo_ip_unpack(), addrinfo_mdump(), addrinfo_mload(), advice_arg_check(), argf_fileno(), argf_rewind(), argf_seek_m(), argf_set_encoding(), argf_set_pos(), argf_tell(), argf_write_io(), ary2safe_array_index(), ary_join_1(), ary_new(), ary_new_dim(), ary_take_first_or_last(), autoload_node(), big2str_find_n1(), big2ulong(), BigDecimal_DoDivmod(), BigDecimal_limit(), BigDecimal_load(), BigDecimal_mode(), BigDecimal_new(), BigDecimal_power(), BigDecimal_to_i(), BigMath_s_exp(), BigMath_s_log(), bit_coerce(), bsock_close_read(), bsock_close_write(), bsock_shutdown(), bubblebabble_str_new(), bug_funcall(), call_cfunc(), call_getaddrinfo(), callback(), caller_setup_args(), cbsubst_def_attr_aliases(), cbsubst_get_subst_arg(), cbsubst_table_setup(), check_before_mod_set(), check_dump_arg(), check_econv(), check_exec_env_i(), check_exec_fds(), check_exec_redirect(), check_exec_redirect_fd(), check_gid_switch(), check_iconv(), check_load_arg(), check_modifiable(), check_rounding_mode(), check_strscan(), check_uid_switch(), chunk_ii(), class2path(), closed_dbm(), closed_sdbm(), coerce_rescue(), constant_arg(), convert_encoding(), convert_type(), copy_stream_body(), copy_stream_fallback(), copy_stream_finalize(), count_nodes(), count_objects(), count_objects_size(), count_tdata_objects(), cParser_initialize(), cParser_parse_quirks_mode(), cParser_parse_strict(), create_dummy_encoding_for_tk_core(), curses_char(), curses_init_screen(), d_lite_initialize_copy(), d_lite_marshal_load(), d_lite_minus(), d_lite_plus(), d_lite_rshift(), d_lite_step(), d_new_by_frags(), date_s__parse_internal(), date_s__strptime_internal(), date_s_civil(), date_s_commercial(), date_s_ordinal(), date_strftime_internal(), datetime_s_civil(), datetime_s_commercial(), datetime_s_jd(), datetime_s_ordinal(), dbl2big(), default_proc_arity_check(), define_final(), dir_check(), dir_closed(), dir_rewind(), dir_s_chdir(), divmodv(), dlhandle_sym(), do_coerce(), do_writeconv(), dt_new_by_frags(), dump_disasm_list(), each_attr_def(), econv_args(), econv_convert(), econv_get_replacement(), econv_init(), econv_insert_output(), econv_opts(), econv_primitive_convert(), econv_set_replacement(), emit(), enc_check_duplication(), enum_chunk(), enum_drop(), enum_each_cons(), enum_each_slice(), enum_first(), enum_sort_by(), enum_take(), enumerator_feed(), enumerator_init(), enumerator_init_copy(), enumerator_initialize(), enumerator_ptr(), env_aset(), env_assoc(), env_delete(), env_fetch(), env_has_key(), errat_setter(), esignal_init(), etc_getgrgid(), etc_getgrnam(), etc_getpwnam(), etc_getpwuid(), ev_advise(), ev_on_event(), eval_string_with_cref(), extract_binmode(), extract_user_token(), f_round_common(), failed_load_conv51932(), fdbm_clear(), fdbm_delete(), fdbm_delete_if(), fdbm_fetch_m(), fdbm_store(), fev_off_event(), fgdbm_clear(), fgdbm_fetch_m(), fgdbm_initialize(), fgdbm_set_cachesize(), fgdbm_set_fastmode(), fgdbm_set_syncmode(), fgdbm_store(), fiber_switch(), fiber_t_alloc(), file_expand_path(), file_inspect_join(), flatten(), fole_initialize(), fole_method_help(), fole_missing(), fole_query_interface(), fole_respond_to(), fole_s_connect(), fole_s_const_load(), fole_s_create_guid(), fole_s_set_locale(), fole_s_show_help(), fole_type(), fole_typelib(), folemethod_initialize(), foleparam_initialize(), foletype_initialize(), foletypelib_initialize(), folevariant_ary_aref(), folevariant_ary_aset(), folevariant_initialize(), folevariant_s_array(), folevariant_set_value(), forbid_setid(), fsdbm_clear(), fsdbm_delete(), fsdbm_delete_if(), fsdbm_fetch_m(), fsdbm_store(), function_call(), gc_stat(), generator_init(), generator_init_copy(), generator_initialize(), generator_ptr(), generic_to_value(), get_addrinfo(), get_device_once(), get_digest_base_metadata(), get_exception_sym2type(), get_gzfile(), get_hash(), get_iconv_opt_i(), get_locked_safe_array(), get_stat(), get_strio(), get_strpath(), get_zstream(), GetPositiveInt(), GetVpValueWithPrec(), gzfile_check_footer(), gzfile_fill(), gzfile_read_header(), gzfile_read_more(), gzfile_read_raw_until_zero(), gzfile_readpartial(), gzfile_s_open(), hash2named_arg(), hash_foreach_call(), hash_foreach_iter(), hash_update(), hexencode_str_new(), hist_delete_at(), hist_get(), host_str(), iconv_convert(), iconv_s_iconv(), id2ref(), init_addrinfo(), init_copy(), Init_tcltklib(), initialize(), initialize_params(), insn_data_to_s_detail(), int_chr(), int_to_ffi_type(), io_getc(), io_getpartial(), io_read(), io_reopen(), io_ungetbyte(), ip_allow_ruby_exit_p(), ip_allow_ruby_exit_set(), ip_cancel_eval_core(), ip_create_console(), ip_create_console_core(), ip_create_slave(), ip_init(), ip_invoke_with_position(), ip_is_safe_p(), ip_is_slave_of_p(), ip_make_menu_embeddable_core(), ip_make_safe(), ip_restart(), ip_ruby_cmd(), ip_ruby_eval(), iseq_build_from_ary_body(), iseq_build_from_ary_exception(), iseq_check(), iseq_load(), JSON_parse_array(), JSON_parse_object(), JSON_parse_value(), lexer_i(), lib_do_one_event_core(), lib_fromUTF8_core(), lib_get_reltype_name(), lib_mainloop_watchdog(), lib_restart(), lib_set_system_encoding(), lib_split_tklist_core(), lib_toUTF8_core(), load_file_internal(), long_toobig(), make_addrinfo(), make_compile_option(), make_exception(), marshal_dump(), marshal_load(), match_backref_number(), match_begin(), match_check(), match_end(), match_init_copy(), match_offset(), method_missing(), mSyslog_close(), mSyslog_log(), mSyslog_open(), mSyslog_set_mask(), must_be_ascii_compatible(), must_encoding(), must_not_be_anonymous(), must_respond_to(), name_to_backref_number(), negative_size_allocation_error(), negative_size_allocation_error_with_gvl(), new_size(), no_window(), nucomp_coerce(), nucomp_marshal_load(), nucomp_rationalize(), nucomp_real_check(), nucomp_s_convert(), nucomp_to_f(), nucomp_to_i(), nucomp_to_r(), num_exact(), num_init_copy(), num_members(), num_sadded(), num_step(), numhash_aref(), numhash_aset(), numhash_i(), nurat_coerce(), nurat_int_check(), nurat_marshal_load(), nurat_s_convert(), offset_to_sec(), old_to_new(), ole_cp2encoding(), ole_create_dcom(), ole_invoke(), ole_invoke2(), ole_raise(), ole_set_byref(), ole_set_safe_array(), ole_val2olevariantdata(), ole_val_ary2variant_ary(), ole_variant2val(), ole_vstr2wc(), oleparam_ole_param_from_index(), onigenc_single_byte_code_to_mbc(), open_key_args(), opt_enc_index(), pack_pack(), pack_unpack(), parse_main(), path2class(), path2module(), path_initialize(), permute0(), pipe_open(), pipe_open_s(), port_str(), prep_window(), prepare_getline_args(), proc_binding(), proc_curry(), proc_new(), proc_options(), r_byte(), r_bytes0(), r_object0(), r_symbol(), r_symlink(), racc_yyparse(), raise_method_missing(), rand_init(), random_load(), random_rand(), range_each(), range_failed(), range_loader(), range_max(), range_step(), rb_alias(), rb_alias_variable(), rb_ary_aset(), rb_ary_combination(), rb_ary_drop(), rb_ary_fetch(), rb_ary_fill(), rb_ary_initialize(), rb_ary_insert(), rb_ary_modify_check(), rb_ary_product(), rb_ary_resize(), rb_ary_sample(), rb_ary_shuffle_bang(), rb_ary_splice(), rb_ary_store(), rb_ary_take(), rb_ary_times(), rb_ary_transpose(), rb_attr(), rb_autoload(), rb_big2long(), rb_big2str0(), rb_big2ulong(), rb_big_coerce(), rb_binding_new(), rb_check_argv(), rb_check_backtrace(), rb_check_convert_type(), rb_check_inheritable(), rb_check_safe_str(), rb_check_type(), rb_check_typeddata(), rb_class_inherited_p(), rb_class_init_copy(), rb_class_initialize(), rb_class_superclass(), rb_cmperr(), rb_const_remove(), rb_const_set(), rb_cont_call(), rb_convert_to_integer(), rb_convert_type(), rb_coverage_result(), rb_cstr_to_dbl(), rb_cstr_to_inum(), rb_declare_transcoder(), rb_define_class(), rb_define_class_id_under(), rb_define_module(), rb_define_module_id_under(), rb_digest_base_alloc(), rb_digest_class_s_digest(), rb_digest_instance_method_unimpl(), rb_dlcfunc2ptr(), rb_dlcfunc_call(), rb_dlhandle_close(), rb_dlhandle_initialize(), rb_dlhandle_sym(), rb_dlptr2cptr(), rb_dlptr_aref(), rb_dlptr_aset(), rb_dlptr_s_to_ptr(), rb_econv_init_by_convpath(), rb_econv_prepare_options(), rb_econv_substr_append(), rb_enc_associate_index(), rb_enc_check(), rb_enc_codelen(), rb_enc_codepoint_len(), rb_enc_cr_str_buf_cat(), rb_enc_find_index(), rb_enc_register(), rb_enc_set_default_external(), rb_enc_uint_chr(), rb_eof_error(), rb_error_frozen(), rb_exec_arg_addopt(), rb_f_at_exit(), rb_f_autoload(), rb_f_caller(), rb_f_eval(), rb_f_getenv(), rb_f_kill(), rb_f_require_relative(), rb_f_sleep(), rb_f_test(), rb_f_trace_var(), rb_fiber_resume(), rb_file_initialize(), rb_file_join(), rb_file_s_basename(), rb_file_s_umask(), rb_find_file_ext_safe(), rb_find_file_safe(), rb_fix2str(), rb_Float(), rb_gdbm_delete(), rb_gdbm_fatal(), rb_get_path_check(), rb_gvar_set(), rb_gzfile_set_comment(), rb_gzfile_set_mtime(), rb_gzfile_set_orig_name(), rb_gzreader_read(), rb_gzreader_readbyte(), rb_gzreader_readchar(), rb_gzreader_readline(), rb_gzreader_readpartial(), rb_hash_fetch_m(), rb_hash_initialize(), rb_hash_modify_check(), rb_hash_rehash(), rb_hash_s_create(), rb_hash_set_default_proc(), rb_home_dir(), rb_include_module(), rb_insecure_operation(), rb_intern3(), rb_interrupt(), rb_invalid_str(), rb_io_check_byte_readable(), rb_io_check_char_readable(), rb_io_check_closed(), rb_io_check_initialized(), rb_io_check_writable(), rb_io_close_m(), rb_io_close_read(), rb_io_close_write(), rb_io_ctl(), rb_io_each_codepoint(), rb_io_each_line(), rb_io_extract_modeenc(), rb_io_fmode_modestr(), rb_io_initialize(), rb_io_modestr_fmode(), rb_io_oflags_modestr(), rb_io_readlines(), rb_io_reopen(), rb_io_s_popen(), rb_io_sysread(), rb_io_sysseek(), rb_io_taint_check(), rb_io_ungetc(), rb_io_wait_readable(), rb_io_wait_writable(), rb_ivar_set(), rb_marshal_define_compat(), rb_method_call(), rb_method_call_status(), rb_method_entry_make(), rb_mod_define_method(), rb_mod_ge(), rb_mod_modfunc(), rb_mod_remove_cvar(), rb_mutex_lock(), rb_mutex_unlock(), rb_nkf_convert(), rb_notimplement(), rb_num2dbl(), rb_num2fix(), rb_num2long(), rb_num2ulong(), rb_num_zerodiv(), rb_obj_alloc(), rb_obj_clone(), rb_obj_dup(), rb_obj_encoding(), rb_obj_extend(), rb_obj_freeze(), rb_obj_init_copy(), rb_obj_is_instance_of(), rb_obj_is_kind_of(), rb_obj_remove_instance_variable(), rb_path_to_class(), rb_provide_feature(), rb_random_real(), rb_range_beg_len(), rb_reg_check(), rb_reg_init_copy(), rb_reg_initialize(), rb_reg_initialize_m(), rb_reg_prepare_enc(), rb_reg_prepare_re(), rb_reg_preprocess_dregexp(), rb_reg_raise(), rb_reg_regsub(), rb_reg_s_union(), rb_register_transcoder(), rb_scan_args(), rb_search_method_entry(), rb_secure(), rb_set_errinfo(), rb_stat_init_copy(), rb_str_aref_m(), rb_str_aset(), rb_str_aset_m(), rb_str_buf_cat(), rb_str_byteslice(), rb_str_cat(), rb_str_check_dummy_enc(), rb_str_concat(), rb_str_count(), rb_str_crypt(), rb_str_delete_bang(), rb_str_ellipsize(), rb_str_format(), rb_str_hex(), rb_str_index_m(), rb_str_justify(), rb_str_match(), rb_str_match_m(), rb_str_modify_expand(), rb_str_new_cstr(), rb_str_oct(), rb_str_partition(), rb_str_resize(), rb_str_rindex_m(), rb_str_rpartition(), rb_str_set_len(), rb_str_setbyte(), rb_str_setter(), rb_str_slice_bang(), rb_str_splice(), rb_str_split_m(), rb_str_sub_bang(), rb_str_subpat_set(), rb_str_times(), rb_str_to_dbl(), rb_str_to_i(), rb_str_unlocktmp(), rb_string_value_cstr(), rb_struct_aref(), rb_struct_aset(), rb_struct_aset_id(), rb_struct_init_copy(), rb_struct_initialize_m(), rb_struct_members(), rb_struct_modify(), rb_struct_s_members(), rb_struct_select(), rb_syck_compile(), rb_syck_err_handler(), rb_thread_local_aref(), rb_thread_local_aset(), rb_thread_stop(), rb_thread_wait_fd_rw(), rb_thread_wakeup(), rb_throw_obj(), rb_time_new(), rb_to_float(), rb_to_id(), rb_to_integer(), rb_undef(), rb_uv_to_utf8(), rb_vm_cbase(), rb_vm_cref(), rb_waitpid(), rb_yield_splat(), rcombinate0(), readable(), readline_attempted_completion_function(), readline_readline(), readline_s_set_completion_proc(), recursive_join(), recursive_pop(), reduce0(), reg_enc_error(), reg_operand(), remain_size(), remove_method(), return_fiber(), ripper_token2eventid(), rpermute0(), rscheck(), rsock_getaddrinfo(), rsock_init_sock(), rsock_io_socket_addrinfo(), rsock_raise_socket_error(), rsock_revlookup_flag(), rsock_s_recvfrom(), rsock_s_recvfrom_nonblock(), ruby__sfvwrite(), RUBY_ALIAS_FUNCTION(), ruby_xrealloc2(), safe_setter(), secure_visibility(), security(), send_internal(), set_arg0(), set_const_visibility(), set_eventloop_tick(), set_eventloop_weight(), set_max_block_time(), set_no_event_wait(), set_ole_codepage(), set_option_encoding_once(), set_trace_func(), sig_trap(), singleton_class_of(), sock_s_gethostbyaddr(), sock_s_getnameinfo(), sock_s_getservbyname(), sock_s_getservbyport(), sock_s_unpack_sockaddr_in(), sock_sockaddr(), sockopt_bool(), sockopt_int(), sockopt_linger(), sort_by_cmp(), sort_by_i(), sort_reentered(), specific_eval(), st_foreach_safe(), start_document(), str_buf_cat(), str_gsub(), str_mod_check(), str_modifiable(), str_new(), str_transcode0(), string_to_c_strict(), string_to_r(), string_to_r_strict(), strio_close(), strio_close_read(), strio_close_write(), strio_each(), strio_read(), strio_readlines(), strio_seek(), strio_size(), strscan_do_scan(), strscan_set_pos(), strscan_unscan(), syck_map_initialize(), syck_map_value_set(), syck_parser_assign_io(), syck_resolver_transfer(), sym_call(), syserr_initialize(), syslog_write(), tcl_stubs_check(), test_check(), thgroup_add(), thread_add_trace_func(), thread_create_core(), thread_initialize(), thread_s_new(), time_fixoff(), time_gmtime(), time_localtime(), time_mdump(), time_mload(), time_modify(), time_overflow_p(), time_plus(), time_round(), time_strftime(), time_timespec(), timegmw(), timelocalw(), timew2timespec(), tk_conv_args(), tk_hash_kv(), tkstr_invalid_numstr(), to_encoding(), transcode_loop(), transcode_restartable0(), trap_handler(), trap_signm(), trnext(), umethod_bind(), update_i(), uscore_get(), utc_offset_arg(), utf8_to_uv(), val2variant_ptr(), validate_enc_binmode(), validate_utc_offset(), validate_vtm(), value_to_generic(), value_to_id(), vm_call0(), vm_call_method(), vm_check_if_namespace(), vm_define_method(), vm_get_cvar_base(), vm_search_superclass(), vm_set_top_stack(), vm_setivar(), VpException(), w_extended(), w_long(), w_object(), w_symbol(), wdivmod(), writable(), wv2timet(), xmalloc2_size(), yielder_init(), and yielder_ptr().

static const char* rb_strerrno | ( | int | err | ) |

static

Definition at line 50 of file error.c.

References NULL.

Referenced by rb_async_bug_errno(), and rb_bug_errno().

void rb_sys_fail | ( | const char * | mesg | ) |

Definition at line 1677 of file error.c.

References make_errno_exc(), and rb_exc_raise().

Referenced by bsock_getpeername(), bsock_getsockname(), bsock_local_address(), bsock_remote_address(), bsock_shutdown(), console_echo_p(), console_iflush(), console_ioflush(), console_oflush(), console_set_cooked(), console_set_echo(), console_set_raw(), copy_stream_body(), copy_stream_finalize(), date_s_today(), date_strftime_alloc(), datetime_s_now(), dir_read(), establishShell(), fdbm_initialize(), fdbm_store(), fgdbm_initialize(), fgdbm_store(), flush_before_seek(), fsdbm_initialize(), fsdbm_store(), init_inetsock_internal(), io_reopen(), io_wait(), ip_addr(), ip_peeraddr(), make_fd_nonblock(), old_thread_select(), ossl_obj2bio(), ossl_ssl_read_internal(), ossl_ssl_write_internal(), ossl_start_ssl(), p_gid_change_privilege(), p_gid_exchange(), p_gid_switch(), p_uid_change_privilege(), p_uid_exchange(), p_uid_switch(), pipe_open(), proc_wait(), proc_waitall(), pty_getpty(), raise_zlib_error(), rb_f_exec(), rb_f_kill(), rb_f_spawn(), rb_fdopen(), rb_io_check_char_readable(), rb_io_flush(), rb_io_initialize(), rb_io_reopen(), rb_io_s_pipe(), rb_io_write_nonblock(), rb_setegid_core(), rb_seteuid_core(), rb_strftime_alloc(), rb_thread_wait_fd_rw(), remain_size(), rsock_bsock_send(), rsock_fd_socket_addrinfo(), rsock_init_sock(), rsock_raise_socket_error(), rsock_s_accept(), rsock_s_accept_nonblock(), rsock_s_recvfrom(), rsock_s_recvfrom_nonblock(), rsock_sock_listen(), ruby_dup(), ruby_getcwd(), ruby_setenv(), select_internal(), sock_bind(), sock_connect(), sock_connect_nonblock(), sock_initialize(), strio_init(), time_init_0(), ttymode(), udp_bind(), udp_connect(), udp_init(), udp_send(), and wait_for_single_fd().

void rb_sys_fail_str | ( | VALUE | mesg | ) |

Definition at line 1683 of file error.c.

References make_errno_exc_str(), and rb_exc_raise().

void rb_sys_warning | ( | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 1721 of file error.c.

References args, buf, errno, RTEST, ruby_verbose, snprintf, strerror(), strlen(), and warn_print().

Referenced by sys_warning_1().

void rb_syserr_fail | ( | int | e,
|  | const char * | mesg
| ) |  |

Definition at line 1665 of file error.c.

References rb_exc_raise(), and rb_syserr_new().

void rb_syserr_fail_str | ( | int | e,
|  | VALUE | mesg
| ) |  |

Definition at line 1671 of file error.c.

References rb_exc_raise(), and rb_syserr_new_str().

VALUE rb_syserr_new | ( | int | n,
|  | const char * | mesg
| ) |  |

Definition at line 1651 of file error.c.

References arg, Qnil, rb_str_new2(), and rb_syserr_new_str().

Referenced by make_errno_exc(), rb_mod_syserr_fail(), and rb_syserr_fail().

VALUE rb_syserr_new_str | ( | int | n,
|  | VALUE | arg
| ) |  |

Definition at line 1659 of file error.c.

References get_syserr(), and rb_class_new_instance().

Referenced by make_errno_exc_str(), rb_mod_syserr_fail_str(), rb_syserr_fail_str(), and rb_syserr_new().

int rb_typeddata_inherited_p | ( | const rb_data_type_t * | child,
|  | const rb_data_type_t * | parent
| ) |  |

Definition at line 420 of file error.c.

References rb_data_type_struct::parent.

Referenced by rb_check_typeddata(), and rb_typeddata_is_kind_of().

int rb_typeddata_is_kind_of | ( | VALUE | obj,
|  | const rb_data_type_t * | data_type
| ) |  |

Definition at line 430 of file error.c.

References BUILTIN_TYPE, rb_typeddata_inherited_p(), RTYPEDDATA_P, RTYPEDDATA_TYPE, SPECIAL_CONST_P, and T_DATA.

Referenced by econv_equal(), enc_check_encoding(), is_kind_of_BigDecimal(), rb_dlcfunc2ptr(), rb_dlcfunc_kind_p(), rb_obj_is_fiber(), rb_obj_is_method(), rb_obj_is_mutex(), rb_obj_is_proc(), rb_obj_is_thread(), and try_get_rnd().

void rb_warn | ( | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 196 of file error.c.

References args, buf, NIL_P, ruby_verbose, snprintf, and warn_print().

Referenced by _nativethread_consistency_check(), argf_next_argv(), curry(), dir_s_chdir(), disable_option(), dump_option(), enable_option(), enum_count(), enum_find_index(), env_fetch(), env_index(), fdbm_index(), fgdbm_index(), fsdbm_index(), generator_initialize(), ignorecase_getter(), ignorecase_setter(), ip_eval_real(), ip_invoke_core(), kcode_getter(), kcode_setter(), make_struct(), marshal_load(), nucomp_expt(), nurat_expt(), onig_syntax_warn(), ossl_cipher_init(), ossl_make_error(), ossl_verify_cb(), parse_mode_enc(), path_check_0(), proc_new(), r_object0(), rb_ary_count(), rb_ary_fetch(), rb_ary_index(), rb_ary_initialize(), rb_ary_rindex(), rb_big_pow(), rb_const_get_0(), rb_const_set(), rb_define_class(), rb_define_class_id_under(), rb_define_const(), rb_enc_find_index(), rb_f_lambda(), rb_fdopen(), rb_hash_fetch_m(), rb_hash_index(), rb_io_extract_encoding_option(), rb_io_reopen(), rb_io_s_new(), rb_io_sysseek(), rb_io_syswrite(), rb_method_entry_make(), rb_reg_initialize_m(), rb_reg_prepare_enc(), rb_run_exec_options_err(), rb_str_format(), rb_time_succ(), rb_undef(), re_warn(), remove_method(), vm_get_cvar_base(), and VpCtoV().

static VALUE rb_warn_m | ( | VALUE | self,
|  | VALUE | mesg
| ) |  |

static

Definition at line 235 of file error.c.

References NIL_P, Qnil, rb_default_rs, rb_io_write(), rb_stderr, and ruby_verbose.

Referenced by Init_Exception().

void rb_warning | ( | const char * | fmt,
|  |  | ...
| ) |  |

Definition at line 212 of file error.c.

References args, buf, RTEST, ruby_verbose, snprintf, and warn_print().

Referenced by _nativethread_consistency_check(), asn1time_to_time(), d_new_by_frags(), datetime_s_now(), dt_new_by_frags(), enum_inject(), generic_ivar_get(), get_eval_string_core(), iconv_create(), ip_eval_real(), ip_invoke_core(), ivar_get(), lib_fromUTF8_core(), lib_toUTF8_core(), load_lock(), offset_to_sec(), old_to_new(), ossl_default_tmp_dh_callback(), ossl_pem_passwd_cb(), ossl_ssl_get_cert(), ossl_ssl_get_cipher(), ossl_ssl_get_client_ca_list(), ossl_ssl_get_peer_cert(), ossl_ssl_get_peer_cert_chain(), ossl_ssl_get_state(), ossl_ssl_get_verify_result(), ossl_ssl_pending(), ossl_ssl_read_internal(), ossl_ssl_session_reused(), ossl_ssl_set_session(), ossl_ssl_write_internal(), ossl_sslctx_get_ciphers(), ossl_sslctx_setup(), rb_ary_initialize(), rb_attr(), rb_big2dbl(), rb_cstr_to_dbl(), rb_cvar_get(), rb_cvar_set(), rb_deflate_params(), rb_enable_super(), rb_glob2(), rb_method_entry_make(), rb_mod_attr(), rb_str_format(), safe_setter(), set_const_visibility(), set_default_external(), set_default_internal(), set_method_visibility(), strscan_clear(), strscan_empty_p(), strscan_getbyte(), strscan_peep(), strscan_restsize(), time_strftime(), top_include(), undef_getter(), vm_getivar(), and zstream_end().

static void report_bug | ( | const char * | file,
|  | int | line,
|  | const char * | fmt,
|  | va_list | args
| ) |  |

static

Definition at line 245 of file error.c.

References buf, err_position_0(), len, rb_vm_bugreport(), REPORTBUG_MSG, and ruby_description.

Referenced by rb_bug(), and rb_compile_bug().

static VALUE set_syserr | ( | int | n,
|  | const char * | name
| ) |  |

static

Definition at line 1058 of file error.c.

References INT2NUM(), rb_define_class_under(), rb_define_const(), rb_eSystemCallError, rb_mErrno, st_add_direct, and st_lookup.

Referenced by get_syserr(), and Init_syserr().

static VALUE syserr_eqq | ( | VALUE | self,
|  | VALUE | exc
| ) |  |

static

Definition at line 1173 of file error.c.

References CONST_ID, FIXNUM_P, NIL_P, Qfalse, Qtrue, rb_attr_get(), rb_const_get(), rb_equal(), rb_eSystemCallError, rb_funcall(), rb_intern, rb_obj_is_kind_of(), and rb_respond_to().

Referenced by Init_Exception().

static VALUE syserr_errno | ( | VALUE | self | ) |

static

Definition at line 1159 of file error.c.

References rb_attr_get(), and rb_intern.

Referenced by Init_Exception().

static VALUE syserr_initialize | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | self
| ) |  |

static

Definition at line 1099 of file error.c.

References err, FIXNUM_P, le, NIL_P, NUM2INT, NUM2LONG(), OBJ_INFECT, Qnil, rb_call_super(), rb_const_get(), rb_enc_asciicompat, rb_enc_associate(), rb_enc_get(), rb_eSystemCallError, rb_eTypeError, rb_intern, rb_iv_set(), rb_locale_encoding(), rb_obj_class(), rb_raise(), rb_scan_args(), rb_sprintf(), rb_str_new2(), RBASIC, RSTRING_LEN, RSTRING_PTR, st_lookup, strerror(), StringValue, T_OBJECT, and TYPE.

Referenced by Init_Exception().

static void warn_print | ( | const char * | fmt,
|  | va_list | args
| ) |  |

static

Definition at line 184 of file error.c.

References buf, err_snprintf(), len, rb_write_error2(), and strlen().

Referenced by rb_sys_warning(), rb_warn(), and rb_warning().

## Variable Documentation

struct types builtin_types[]

static

Initial value:
= {
{T_NIL, "nil"},
{T_OBJECT, "Object"},
{T_CLASS, "Class"},
{T_ICLASS, "iClass"},
{T_MODULE, "Module"},
{T_FLOAT, "Float"},
{T_STRING, "String"},
{T_REGEXP, "Regexp"},
{T_ARRAY, "Array"},
{T_FIXNUM, "Fixnum"},
{T_HASH, "Hash"},
{T_STRUCT, "Struct"},
{T_BIGNUM, "Bignum"},
{T_FILE, "File"},
{T_RATIONAL,"Rational"},
{T_COMPLEX, "Complex"},
{T_TRUE, "true"},
{T_FALSE, "false"},
{T_SYMBOL, "Symbol"},
{T_DATA, "Data"},
{T_MATCH, "MatchData"},
{T_NODE, "Node"},
{T_UNDEF, "undef"},
}

Referenced by rb_check_type().

const rb_data_type_t name_err_mesg_data_type

static

Initial value:
= {
"name_err_mesg",
{
name_err_mesg_mark,
name_err_mesg_free,
name_err_mesg_memsize,
},
}

Definition at line 900 of file error.c.

VALUE rb_cNameErrorMesg

Definition at line 479 of file error.c.

Referenced by Init_Exception(), name_err_mesg_equal(), and rb_name_err_mesg_new().

VALUE rb_eArgError

Definition at line 468 of file error.c.

Referenced by argf_fileno(), argf_rewind(), argf_seek_m(), argf_set_encoding(), argf_set_pos(), argf_tell(), argument_error(), ary2safe_array_index(), ary_join_1(), ary_new(), ary_take_first_or_last(), autoload_node(), BigDecimal_limit(), BigDecimal_mode(), BigDecimal_new(), BigMath_s_exp(), BigMath_s_log(), bsock_shutdown(), bug_funcall(), call_cfunc(), cbsubst_def_attr_aliases(), cbsubst_get_subst_arg(), cbsubst_table_setup(), check_exec_env_i(), check_exec_fds(), check_exec_redirect(), check_exec_redirect_fd(), check_iconv(), check_rounding_mode(), copy_stream_fallback(), cParser_initialize(), create_dummy_encoding_for_tk_core(), curses_char(), d_lite_initialize_copy(), d_lite_marshal_load(), d_lite_rshift(), d_lite_step(), d_new_by_frags(), date_s__parse_internal(), date_s__strptime_internal(), date_s_civil(), date_s_commercial(), date_s_ordinal(), date_strftime_internal(), datetime_s_civil(), datetime_s_commercial(), datetime_s_jd(), datetime_s_ordinal(), define_final(), dir_s_chdir(), do_writeconv(), dt_new_by_frags(), DupPrivPKeyPtr(), each_attr_def(), econv_args(), econv_convert(), econv_insert_output(), econv_opts(), econv_primitive_convert(), enc_check_duplication(), enum_chunk(), enum_drop(), enum_each_cons(), enum_each_slice(), enum_first(), enum_take(), enumerator_init(), enumerator_init_copy(), enumerator_initialize(), enumerator_ptr(), env_aset(), env_assoc(), env_delete(), env_fetch(), env_has_key(), errat_setter(), esignal_init(), etc_getgrgid(), etc_getgrnam(), etc_getpwnam(), etc_getpwuid(), extract_binmode(), extract_user_token(), file_expand_path(), file_inspect_join(), flatten(), foletypelib_initialize(), folevariant_initialize(), function_call(), generator_init(), generator_init_copy(), generator_ptr(), get_hash(), get_iconv_opt_i(), GetPositiveInt(), GetPrivPKeyPtr(), GetVpValueWithPrec(), gzfile_fill(), gzfile_readpartial(), gzfile_s_open(), host_str(), iconv_convert(), iconv_s_iconv(), init_addrinfo(), Init_Exception(), Init_iconv(), int_chr(), io_getpartial(), io_read(), io_reopen(), ip_invoke_with_position(), ip_is_slave_of_p(), ip_make_menu_embeddable_core(), ip_ruby_cmd(), ip_ruby_eval(), lexer_i(), lib_fromUTF8_core(), lib_set_system_encoding(), lib_toUTF8_core(), make_exception(), mSyslog_log(), must_be_ascii_compatible(), nucomp_marshal_load(), num_step(), numhash_aref(), numhash_aset(), nurat_marshal_load(), old_to_new(), open_key_args(), ossl_bn_initialize(), ossl_bn_to_s(), ossl_cipher_update(), ossl_pkcs12_s_create(), ossl_pkcs7_initialize(), ossl_pkey_new_from_data(), ossl_pkey_sign(), ossl_ssl_session_initialize(), ossl_sslctx_flush_sessions(), ossl_sslctx_set_ssl_version(), pack_pack(), pack_unpack(), parse_main(), parser_set_encode(), path2class(), path2module(), path_initialize(), pipe_open(), port_str(), prepare_getline_args(), proc_binding(), proc_curry(), proc_new(), r_byte(), r_bytes0(), r_object0(), r_symbol(), r_symlink(), racc_yyparse(), raise_method_missing(), random_load(), random_rand(), range_failed(), range_step(), rb_ary_aset(), rb_ary_drop(), rb_ary_fill(), rb_ary_initialize(), rb_ary_insert(), rb_ary_sample(), rb_ary_shuffle_bang(), rb_ary_take(), rb_ary_times(), rb_attr(), rb_autoload(), rb_big2str0(), rb_check_argv(), rb_cmperr(), rb_convert_to_integer(), rb_cstr_to_dbl(), rb_cstr_to_inum(), rb_declare_transcoder(), rb_digest_class_s_digest(), rb_econv_init_by_convpath(), rb_econv_prepare_options(), rb_econv_substr_append(), rb_enc_associate_index(), rb_enc_codelen(), rb_enc_codepoint_len(), rb_enc_cr_str_buf_cat(), rb_enc_find_index(), rb_enc_register(), rb_enc_set_default_external(), rb_exec_arg_addopt(), rb_f_at_exit(), rb_f_caller(), rb_f_getenv(), rb_f_kill(), rb_f_sleep(), rb_f_test(), rb_file_join(), rb_file_s_umask(), rb_fix2str(), rb_gzreader_read(), rb_gzreader_readpartial(), rb_hash_initialize(), rb_hash_s_create(), rb_home_dir(), rb_include_module(), rb_invalid_str(), rb_io_ctl(), rb_io_each_codepoint(), rb_io_each_line(), rb_io_extract_modeenc(), rb_io_fmode_modestr(), rb_io_initialize(), rb_io_modestr_fmode(), rb_io_oflags_modestr(), rb_io_readlines(), rb_io_reopen(), rb_io_s_popen(), rb_mod_define_method(), rb_nkf_convert(), rb_obj_extend(), rb_path_to_class(), rb_reg_initialize_m(), rb_reg_prepare_enc(), rb_reg_prepare_re(), rb_reg_preprocess_dregexp(), rb_reg_s_union(), rb_register_transcoder(), rb_scan_args(), rb_str_aref_m(), rb_str_aset_m(), rb_str_buf_cat(), rb_str_byteslice(), rb_str_cat(), rb_str_count(), rb_str_crypt(), rb_str_delete_bang(), rb_str_format(), rb_str_justify(), rb_str_match_m(), rb_str_modify_expand(), rb_str_new_cstr(), rb_str_resize(), rb_str_slice_bang(), rb_str_split_m(), rb_str_sub_bang(), rb_str_times(), rb_str_to_dbl(), rb_str_to_i(), rb_string_value_cstr(), rb_struct_initialize_m(), rb_struct_select(), rb_syck_err_handler(), rb_syck_mktime(), rb_throw_obj(), rb_waitpid(), rb_yield_splat(), readline_s_set_completion_proc(), recursive_join(), rsock_init_sock(), rsock_revlookup_flag(), ruby_xrealloc2(), send_internal(), set_eventloop_tick(), set_eventloop_weight(), set_max_block_time(), set_no_event_wait(), sig_trap(), sock_s_getnameinfo(), sock_s_unpack_sockaddr_in(), specific_eval(), str_buf_cat(), str_gsub(), str_new(), str_transcode0(), string_to_c_strict(), string_to_r_strict(), strio_each(), strio_read(), strio_readlines(), sym_call(), syslog_write(), tcl2rb_num_or_str(), test_check(), time_fixoff(), time_gmtime(), time_localtime(), time_mdump(), time_overflow_p(), time_round(), time_strftime(), time_timespec(), timegmw(), timelocalw(), timew2timespec(), tk_conv_args(), tk_hash_kv(), tkstr_invalid_numstr(), tkstr_rescue_float(), tkstr_to_number(), to_encoding(), transcode_loop(), trap_handler(), trap_signm(), trnext(), update_i(), utc_offset_arg(), utf8_to_uv(), validate_enc_binmode(), validate_utc_offset(), validate_vtm(), vm_call0(), vm_call_method(), w_object(), xmalloc2_size(), yielder_init(), and yielder_ptr().

VALUE rb_eEncCompatError

Definition at line 474 of file error.c.

Referenced by Init_Exception(), rb_enc_check(), rb_enc_cr_str_buf_cat(), rb_file_s_basename(), rb_get_path_check(), rb_str_check_dummy_enc(), rb_str_hex(), rb_str_oct(), rb_str_sub_bang(), and reg_enc_error().

VALUE rb_eEncodingError

Definition at line 473 of file error.c.

Referenced by Init_Exception(), Init_transcode(), and rb_intern3().

VALUE rb_eException

Definition at line 460 of file error.c.

Referenced by Init_Exception(), Init_gdbm(), Init_Proc(), ip_eval(), ip_eval_real(), ip_invoke_core(), ip_invoke_with_position(), lib_eventloop_core(), lib_eventloop_main(), make_exception(), pending_exception_check0(), pending_exception_check1(), rb_set_errinfo(), tcl_protect_core(), and tk_funcall().

VALUE rb_eFatal

Definition at line 464 of file error.c.

Referenced by Init_eval(), Init_Exception(), ip_eval_real(), ip_invoke_core(), lib_eventloop_core(), lib_eventloop_main(), rb_check_deadlock(), rb_fatal(), and tcl_protect_core().

VALUE rb_eIndexError

Definition at line 469 of file error.c.

Referenced by fdbm_fetch_m(), fgdbm_fetch_m(), fsdbm_fetch_m(), hist_delete_at(), hist_get(), Init_Enumerator(), Init_Exception(), match_backref_number(), match_begin(), match_end(), match_offset(), name_to_backref_number(), oleparam_ole_param_from_index(), rb_ary_fetch(), rb_ary_resize(), rb_ary_splice(), rb_ary_store(), rb_ary_transpose(), rb_str_aset(), rb_str_ellipsize(), rb_str_setbyte(), rb_str_splice(), rb_str_subpat_set(), rb_struct_aref(), and rb_struct_aset().

VALUE rb_eInterrupt

Definition at line 462 of file error.c.

Referenced by Init_Exception(), Init_signal(), ip_rbTkWaitCommand(), ip_rbUpdateCommand(), ip_rbVwaitCommand(), rb_interrupt(), and tcl_protect_core().

VALUE rb_eKeyError

Definition at line 470 of file error.c.

Referenced by env_fetch(), Init_Exception(), rb_hash_fetch_m(), and rb_str_format().

VALUE rb_eLoadError

Definition at line 483 of file error.c.

Referenced by Init_Exception(), Init_tcltklib(), ip_init(), load_failed(), load_file_internal(), rb_f_require_relative(), rb_loaderror(), tcl_stubs_check(), and tcltkip_init_tk().

VALUE rb_eNameError

Definition at line 472 of file error.c.

Referenced by Init_Exception(), ip_invoke_core(), process_sflag(), raise_method_missing(), rb_autoload(), and rb_name_error().

VALUE rb_eNOERROR

static

Definition at line 487 of file error.c.

Referenced by Init_syserr().

VALUE rb_eNoMemError

Definition at line 478 of file error.c.

Referenced by Init_Exception(), Init_GC(), negative_size_allocation_error(), negative_size_allocation_error_with_gvl(), and readline_attempted_completion_function().

VALUE rb_eNoMethodError

Definition at line 475 of file error.c.

Referenced by check_funcall(), gzfile_read_raw(), gzfile_read_raw_rescue(), Init_Exception(), ole_invoke(), raise_method_missing(), and vm_search_superclass().

VALUE rb_eNotImpError

Definition at line 477 of file error.c.

Referenced by advice_arg_check(), copy_stream_finalize(), Init_Exception(), ip_cancel_eval_core(), lib_mainloop_watchdog(), ossl_pkey_initialize(), pipe_open_s(), rb_digest_base_alloc(), rb_notimplement(), and rb_search_method_entry().

VALUE rb_eRangeError

Definition at line 471 of file error.c.

Referenced by big2str_find_n1(), big2ulong(), id2ref(), Init_Exception(), Init_Numeric(), int_chr(), nucomp_rationalize(), nucomp_to_f(), nucomp_to_i(), nucomp_to_r(), onigenc_single_byte_code_to_mbc(), pack_pack(), pack_unpack(), rb_ary_product(), rb_big2long(), rb_big2ulong(), rb_enc_uint_chr(), rb_num2fix(), rb_num2long(), rb_num2ulong(), rb_random_real(), rb_range_beg_len(), rb_str_concat(), rb_time_new(), rb_uv_to_utf8(), sock_s_getservbyport(), strscan_set_pos(), time_overflow_p(), time_timespec(), and wv2timet().

VALUE rb_eRuntimeError

Definition at line 466 of file error.c.

Referenced by ary2safe_array_index(), ary_new_dim(), bubblebabble_str_new(), callback(), check_dump_arg(), check_gid_switch(), check_load_arg(), check_uid_switch(), chunk_ii(), closed_dbm(), create_dummy_encoding_for_tk_core(), curses_init_screen(), emit(), enum_sort_by(), error_print(), ev_advise(), eval_string_with_cref(), fiber_t_alloc(), flatten(), fole_each(), fole_method_help(), fole_missing(), fole_query_interface(), fole_s_const_load(), fole_s_create_guid(), fole_s_show_help(), fole_type(), fole_typelib(), folevariant_ary_aset(), folevariant_s_array(), generic_to_value(), get_device_once(), get_digest_base_metadata(), get_locked_safe_array(), GetDigestPtr(), hash_foreach_call(), hash_foreach_iter(), hash_update(), hexencode_str_new(), Init_cparse(), Init_Exception(), Init_iconv(), Init_ossl_bn(), Init_pty(), Init_win32ole(), initialize(), int_to_ffi_type(), ip_allow_ruby_exit_p(), ip_allow_ruby_exit_set(), ip_create_console(), ip_create_console_core(), ip_create_slave(), ip_create_slave_core(), ip_eval_real(), ip_get_variable2_core(), ip_init(), ip_invoke_core(), ip_is_safe_p(), ip_make_menu_embeddable_core(), ip_make_safe(), ip_make_safe_core(), ip_rb_threadTkWaitCommand(), ip_rb_threadUpdateCommand(), ip_rb_threadVwaitCommand(), ip_rbTkWaitCommand(), ip_rbUpdateCommand(), ip_rbVwaitCommand(), ip_restart(), ip_ruby_cmd(), ip_ruby_eval(), ip_set_variable2_core(), ip_unset_variable2_core(), lib_do_one_event_core(), lib_get_reltype_name(), lib_restart(), lib_restart_core(), lib_split_tklist_core(), make_exception(), mSyslog_close(), mSyslog_open(), mSyslog_set_mask(), new_size(), no_window(), numhash_i(), ole_create_dcom(), ole_initialize(), ole_invoke(), ole_pure_initialize(), ole_set_safe_array(), ole_val2olevariantdata(), ole_val_ary2variant_ary(), ole_variant2val(), oleparam_ole_param_from_index(), opt_enc_index(), ossl_cipher_initialize(), ossl_digest_alloc(), pack_pack(), permute0(), prep_window(), proc_options(), rb_alias_variable(), rb_ary_combination(), rb_ary_product(), rb_ary_shuffle_bang(), rb_binding_new(), rb_cont_call(), rb_coverage_result(), rb_digest_instance_method_unimpl(), rb_error_frozen(), rb_file_initialize(), rb_hash_rehash(), rb_intern3(), rb_provide_feature(), rb_reg_regsub(), rb_str_set_len(), rb_str_unlocktmp(), rb_vm_cbase(), rb_vm_cref(), rcombinate0(), ripper_token2eventid(), rpermute0(), rscheck(), rsock_s_recvfrom(), ruby__sfvwrite(), RUBY_ALIAS_FUNCTION(), set_arg0(), set_option_encoding_once(), setup_exception(), sort_by_cmp(), sort_by_i(), sort_reentered(), st_foreach_safe(), start_document(), str_gsub(), str_mod_check(), str_modifiable(), syslog_write(), tcl_stubs_check(), tcltkip_init_tk(), transcode_restartable0(), typeinfo_from_ole(), unlock_safe_array(), val2variant_ptr(), value_to_generic(), vm_search_superclass(), and w_object().

VALUE rb_eScriptError

Definition at line 481 of file error.c.

Referenced by Init_Exception().

VALUE rb_eSecurityError

Definition at line 476 of file error.c.

Referenced by bsock_close_read(), bsock_close_write(), bsock_shutdown(), check_before_mod_set(), dir_check(), dir_rewind(), env_aset(), ev_advise(), fole_initialize(), fole_s_connect(), forbid_setid(), Init_Exception(), io_reopen(), ip_allow_ruby_exit_set(), ip_init(), rb_alias_variable(), rb_ary_modify_check(), rb_const_remove(), rb_f_eval(), rb_f_trace_var(), rb_find_file_ext_safe(), rb_find_file_safe(), rb_gvar_set(), rb_hash_modify_check(), rb_insecure_operation(), rb_io_close_m(), rb_io_close_read(), rb_io_close_write(), rb_io_taint_check(), rb_ivar_set(), rb_method_call_status(), rb_method_entry_make(), rb_mod_remove_cvar(), rb_obj_freeze(), rb_obj_remove_instance_variable(), rb_reg_initialize(), rb_secure(), rb_struct_modify(), rb_thread_local_aref(), rb_thread_local_aset(), rb_undef(), remove_method(), safe_setter(), secure_visibility(), security(), set_const_visibility(), sig_trap(), str_modifiable(), thread_start_func_2(), time_modify(), vm_call_method(), and vm_setivar().

VALUE rb_eSignal

Definition at line 463 of file error.c.

Referenced by error_handle(), Init_Exception(), Init_signal(), rb_threadptr_signal_raise(), and ruby_cleanup().

VALUE rb_eStandardError

Definition at line 465 of file error.c.

Referenced by exp1(), Init_Cont(), Init_dbm(), Init_dl(), Init_Exception(), Init_gdbm(), Init_IO(), Init_Numeric(), Init_openssl(), Init_Proc(), Init_Regexp(), Init_sdbm(), Init_strscan(), Init_tcltklib(), Init_Thread(), Init_zlib(), iseq_compile_each(), rb_rescue(), and rsock_init_socket_init().

VALUE rb_eSyntaxError

Definition at line 482 of file error.c.

Referenced by dump_disasm_list(), err_append(), get_exception_sym2type(), Init_Exception(), Init_psych_parser(), insn_data_to_s_detail(), iseq_build_from_ary_body(), iseq_build_from_ary_exception(), and rb_syck_compile().

VALUE rb_eSystemCallError

Definition at line 485 of file error.c.

Referenced by float_value(), Init_Exception(), rb_io_initialize(), set_syserr(), syserr_eqq(), and syserr_initialize().

VALUE rb_eSystemExit

Definition at line 461 of file error.c.

Referenced by error_handle(), Init_Exception(), ip_rbTkWaitCommand(), ip_rbUpdateCommand(), ip_rbVwaitCommand(), ip_RubyExitCommand(), rb_exit(), rb_f_abort(), rb_threadptr_signal_exit(), ruby_cleanup(), setup_exception(), tcl_protect_core(), and thread_start_func_2().

VALUE rb_eTypeError

Definition at line 467 of file error.c.

Referenced by addrinfo_initialize(), addrinfo_mload(), advice_arg_check(), asn1integer_to_num(), asn1time_to_time(), BigDecimal_load(), BigDecimal_mode(), BigDecimal_power(), bit_coerce(), caller_setup_args(), check_econv(), check_strscan(), class2path(), coerce_rescue(), convert_type(), count_nodes(), count_objects(), count_objects_size(), count_tdata_objects(), cParser_initialize(), d_lite_marshal_load(), d_lite_minus(), d_lite_plus(), default_proc_arity_check(), divmodv(), do_coerce(), econv_init(), enumerator_feed(), enumerator_init_copy(), ev_advise(), ev_on_event(), eval_string_with_cref(), extract_user_token(), f_round_common(), fev_off_event(), fole_respond_to(), fole_s_const_load(), fole_s_show_help(), folemethod_initialize(), foleparam_initialize(), folevariant_initialize(), gc_stat(), generator_initialize(), get_addrinfo(), get_locked_safe_array(), get_stat(), get_strpath(), GetBNPtr(), GetVpValueWithPrec(), hash2named_arg(), init_copy(), Init_Exception(), iseq_build_from_ary_body(), iseq_check(), iseq_load(), long_toobig(), make_compile_option(), make_exception(), marshal_dump(), marshal_load(), match_check(), match_init_copy(), method_missing(), mSyslog_log(), must_encoding(), must_not_be_anonymous(), must_respond_to(), nucomp_coerce(), nucomp_real_check(), nucomp_s_convert(), num_exact(), num_init_copy(), num_members(), num_sadded(), nurat_coerce(), nurat_int_check(), nurat_s_convert(), offset_to_sec(), ole_invoke(), ole_invoke2(), ossl_bn_coerce(), ossl_dh_new(), ossl_dsa_new(), ossl_rsa_new(), r_object0(), rand_init(), range_each(), range_loader(), range_max(), range_step(), rb_alias(), rb_big_coerce(), rb_check_backtrace(), rb_check_convert_type(), rb_check_inheritable(), rb_check_safe_str(), rb_check_type(), rb_check_typeddata(), rb_class_inherited_p(), rb_class_init_copy(), rb_class_initialize(), rb_class_superclass(), rb_const_set(), rb_convert_to_integer(), rb_convert_type(), rb_define_class(), rb_define_class_id_under(), rb_define_module(), rb_define_module_id_under(), rb_dlcfunc2ptr(), rb_dlptr2cptr(), rb_f_autoload(), rb_Float(), rb_hash_set_default_proc(), rb_marshal_define_compat(), rb_method_call(), rb_mod_define_method(), rb_mod_ge(), rb_mod_modfunc(), rb_num2dbl(), rb_num2long(), rb_num2ulong(), rb_obj_alloc(), rb_obj_clone(), rb_obj_dup(), rb_obj_encoding(), rb_obj_init_copy(), rb_obj_is_instance_of(), rb_obj_is_kind_of(), rb_path_to_class(), rb_reg_check(), rb_reg_init_copy(), rb_reg_initialize(), rb_set_errinfo(), rb_stat_init_copy(), rb_str_index_m(), rb_str_match(), rb_str_partition(), rb_str_rindex_m(), rb_str_rpartition(), rb_str_setter(), rb_struct_aset_id(), rb_struct_init_copy(), rb_struct_members(), rb_struct_s_members(), rb_to_float(), rb_to_id(), rb_to_integer(), rb_undef(), recursive_pop(), reg_operand(), rsock_io_socket_addrinfo(), rsock_s_recvfrom(), set_trace_func(), singleton_class_of(), sock_s_getnameinfo(), sockopt_bool(), sockopt_int(), sockopt_linger(), syck_map_initialize(), syck_map_value_set(), syck_parser_assign_io(), syck_resolver_transfer(), syserr_initialize(), thread_add_trace_func(), time_mload(), time_plus(), time_timespec(), umethod_bind(), uscore_get(), value_to_id(), vm_check_if_namespace(), vm_define_method(), vm_get_cvar_base(), vm_set_top_stack(), w_extended(), w_long(), w_object(), w_symbol(), and wdivmod().

VALUE rb_mErrno

Definition at line 486 of file error.c.

Referenced by Init_Exception(), path_unlink(), and set_syserr().

const char ruby_description[]

Definition at line 68 of file version.c.

Referenced by rb_async_bug_errno(), and report_bug().

st_table* syserr_tbl

static

Definition at line 1055 of file error.c.